/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include <stdexcept>

class CBasicException :	public std::exception {
public:
	CBasicException(const char error[]) throw();
	CBasicException(const CBasicException &we) throw();
	virtual ~CBasicException() throw();

	CBasicException& operator=(const CBasicException& rhs) throw();

	virtual const char *what() const throw();

private:
	static const int _maxLength = 256;

	char _errorMessage[_maxLength];
};
