#pragma once

#include "afxwin.h"
#include "Sequence.h"

class CEditSequenceDialog : public CDialog
{
	DECLARE_DYNAMIC(CEditSequenceDialog)

public:
	CEditSequenceDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CEditSequenceDialog();

	enum { IDD = IDD_EDIT_SEQUENCE_DIALOG };

	Sequence GetSequence() const;

	virtual BOOL OnInitDialog();

	afx_msg void OnBnClickedAddDependent();
	afx_msg void OnBnClickedRemoveFromSequence();
	afx_msg void OnCbnSelchangeIndependentTrial();
	afx_msg void OnDeltaposSequenceTrial(NMHDR *pNMHDR, LRESULT *pResult);

	void SetSequence(Sequence &sequence);
	void SetTrials(const IdentifierList &indep, const IdentifierList &dep);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();

	DECLARE_MESSAGE_MAP()

private:
	void updateButtonList();
	CListBox mListButtons;
	CComboBox m_listButtons;

	CComboBox m_comboIndependent;
	CListBox  m_listDependent;
	CListBox  m_listSequence;
	CListBox  m_listAltSequence;


	IdentifierList _independent;
	IdentifierList _dependent;
	IdentifierList _sequence;
	IdentifierList _altSequence;
	TrialId        _indepId;
	TrialId        _seqId;
	int            _length;
	int				_altLength;
	int				_altSelectButton;
	bool			_altEnabled;
public:
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedButtonAddDependent2();
	afx_msg void OnBnClickedButtonRemoveFromSequence2();
	afx_msg void OnLbnSelchangeListTrialtypeButtons();
	afx_msg void OnCbnSelchangeComboAltSelectButton();
	afx_msg void OnLbnSelchangeListDependentTrials();
	afx_msg void OnLbnSelchangeListSequenceTrials();
	afx_msg void OnBnClickedCheckEnableAltSequence();
};
