/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include <string>
#include "AudioRender.h"

class CEditTrialAudioDialog : public CDialog
{
	DECLARE_DYNAMIC(CEditTrialAudioDialog)

public:
	CEditTrialAudioDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CEditTrialAudioDialog();

	enum { IDD = IDD_EDIT_TRIAL_AUDIO_DIALOG };

	AudioRenderData &RenderData();

	virtual BOOL OnInitDialog();

	afx_msg void OnBnClickedBrowse();
	afx_msg void OnBnClickedAudioEnable();
	afx_msg void OnEnKillfocusEditAudioFile();
	afx_msg void OnEnKillfocusEditStartDelay();
	afx_msg void OnEnKillfocusEditStopDelay();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();

	DECLARE_MESSAGE_MAP()

private:
	AudioRenderData _data;
	bool            _isEnabled;
public:
	afx_msg void OnEnChangeEditTrialAudioStart();
};
