/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include "afxwin.h"
#include "AudioRender.h"
#include "DisplayData.h"
#include "Experiment.hpp"

class CEditTrialDialog : public CDialog
{
	DECLARE_DYNAMIC(CEditTrialDialog)

public:
	CEditTrialDialog(CWnd *pParent, const Experiment *expt);
	virtual ~CEditTrialDialog();

	enum { IDD = IDD_EDIT_TRIAL_DIALOG };

	Trial GetTrial() const;

	virtual BOOL OnInitDialog();

	afx_msg void OnBnClickedChangeAudio();
	afx_msg void OnBnClickedChangeDisplay();
	afx_msg void OnBnClickedChangeProperties();

	void OnEditDisplayDialogOkay();
	void SetTrial(const Trial *t);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();

	void UpdateAudioData();
	void UpdateDisplayData();
	void UpdatePropertyData();

	DECLARE_MESSAGE_MAP()

private:
	const Experiment     *_expt;
	CWnd                 *_editDisplayDlg;
	AudioRenderData       _audio;
	DisplayData           _display;
	TrialId				  _identifier;
	Tokenizer::ButtonType _answer;
	std::string			  _typeName;
	int					  _displayTime;
	Tokenizer::ControlType _controlType;

public:
	afx_msg void OnBnClickedCancel();
};
