// EditTrialImagesDialog.cpp : implementation file
//
#include <sstream>
#include "stdafx.h"
#include "EyeTrack.h"
#include "EditTrialImagesDialog.h"
#include "EditTrialDisplayDialog.h"
#include ".\edittrialimagesdialog.h"


// EditTrialImagesDialog dialog

IMPLEMENT_DYNAMIC(CEditTrialImagesDialog, CDialog)
CEditTrialImagesDialog::CEditTrialImagesDialog(CWnd* pParent /*=NULL*/,DisplayData dd, unsigned int whichDisplay)
	: CDialog(CEditTrialImagesDialog::IDD, pParent), _display(dd), _whichDisplay(whichDisplay)
{
}

CEditTrialImagesDialog::~CEditTrialImagesDialog()
{
}


void CEditTrialImagesDialog::Initialize(DisplayData dd, unsigned int whichDisplay)
{
	if (_whichDisplay == 2)
		images = &(dd.images2);
	else if(_whichDisplay == 3)
		images = &(dd.images3);
	else 
		images = &(dd.images1);

	if (_whichDisplay == 1 && !dd.images1.empty()) {
		CListBox &lb = *((CListBox*)GetDlgItem(IDC_LIST_IMAGE_POSITIONS));

		for(unsigned int i =0; i < dd.images1.size(); ++i){
			std::string file = dd.images1.at(i).fileName;
			CPoint pt = dd.images1.at(i).upperLeft;
			std::ostringstream os;
			os << '(' <<pt.x << ' ' << pt.y << ") "<< file;
//			os << '('<<r1.top<<' '<<r1.left<<' '<<r1.bottom<<' '<<r1.right<<") -> ("<<r2.top<<' '<<r2.left<<' '<<r2.bottom<<' '<<r2.right<<')';
			lb.AddString(os.str().c_str());
		}
	return;
	}

	if (_whichDisplay == 2 && !dd.images2.empty()) {
		CListBox &lb = *((CListBox*)GetDlgItem(IDC_LIST_IMAGE_POSITIONS));

		for(unsigned int i =0; i < dd.images2.size(); ++i){
			std::string file = dd.images2.at(i).fileName;
			CPoint pt = dd.images2.at(i).upperLeft;
			std::ostringstream os;
			os << '(' <<pt.x << ' ' << pt.y << ") "<< file;
//			os << '('<<r1.top<<' '<<r1.left<<' '<<r1.bottom<<' '<<r1.right<<") -> ("<<r2.top<<' '<<r2.left<<' '<<r2.bottom<<' '<<r2.right<<')';
			lb.AddString(os.str().c_str());
		}
	return;
	}

	if(_whichDisplay == 3 && !dd.images3.empty()){
	CListBox &lb = *((CListBox*)GetDlgItem(IDC_LIST_IMAGE_POSITIONS));

		for(unsigned int i =0; i < dd.images3.size(); ++i){
			std::string file = dd.images3.at(i).fileName;
			CPoint pt = dd.images3.at(i).upperLeft;
			std::ostringstream os;
			os << '(' <<pt.x << ' ' << pt.y << ") "<< file;
//			os << '('<<r1.top<<' '<<r1.left<<' '<<r1.bottom<<' '<<r1.right<<") -> ("<<r2.top<<' '<<r2.left<<' '<<r2.bottom<<' '<<r2.right<<')';
			lb.AddString(os.str().c_str());
		}
	return;
	}
}

void CEditTrialImagesDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BOOL CEditTrialImagesDialog::OnInitDialog()
{
	CDialog::OnInitDialog();
	Initialize(_display,_whichDisplay);	

	return TRUE;
}

BEGIN_MESSAGE_MAP(CEditTrialImagesDialog, CDialog)
	ON_LBN_SELCHANGE(IDC_LIST_IMAGE_POSITIONS, OnLbnSelChangeImagePos)
	ON_BN_CLICKED(ID_ADD_IMAGES_OK, OnBnClickedAddImagesOk)
	ON_BN_CLICKED(IDC_ADD_IMAGES_CANCEl, OnBnClickedAddImagesCancel)
	ON_BN_CLICKED(IDC_BUTTON_ADD_IMAGE, OnBnClickedButtonAddImage)
	ON_BN_CLICKED(IDC_BUTTON_UPDATE_IMAGE, OnBnClickedButtonUpdateImage)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_IMAGE, OnBnClickedButtonDeleteImage)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE_IMAGES, OnBnClickedButtonBrowseImages)
	ON_EN_CHANGE(IDC_EDIT_ADD_IMAGE_PATH, OnEnChangeEditAddImagePath)
END_MESSAGE_MAP()


// EditTrialImagesDialog message handlers

void CEditTrialImagesDialog::OnLbnSelChangeImagePos()
{
	CListBox &lb = *((CListBox*)GetDlgItem(IDC_LIST_IMAGE_POSITIONS));
	int idx = lb.GetCurSel();
	char buf[25];

	if (idx == LB_ERR)
		return;

	IMAGEPOS ip;
	if(_whichDisplay == 2)
		ip = _display.images2.at(idx);
	else if(_whichDisplay == 3)
		ip = _display.images3.at(idx);
	else
		ip = _display.images1.at(idx);
	GetDlgItem(IDC_EDIT_ADD_IMAGES_X1)->SetWindowText(_itoa(ip.upperLeft.x, buf, 10));
	GetDlgItem(IDC_EDIT_ADD_IMAGES_Y1)->SetWindowText(_itoa(ip.upperLeft.y, buf, 10));
	GetDlgItem(IDC_EDIT_ADD_IMAGE_PATH)->SetWindowText(ip.fileName.c_str());
	// TODO: Add your control notification handler code here
}


void CEditTrialImagesDialog::OnBnClickedAddImagesOk()
{
	CDialog::OnOK();
	// TODO: Add your control notification handler code here
}

void CEditTrialImagesDialog::OnBnClickedAddImagesCancel()
{
	OnCancel();
	// TODO: Add your control notification handler code here
}

void CEditTrialImagesDialog::OnBnClickedButtonAddImage()
{
	const int MAX_LEN = 200;
	CListBox &lb = *((CListBox*)GetDlgItem(IDC_LIST_IMAGE_POSITIONS));
//	int idx = lb.GetCurSel();
	char buf[MAX_LEN+1];

//	if (idx == LB_ERR)
//		return;

	IMAGEPOS ip;
	CPoint pt;

	GetDlgItem(IDC_EDIT_ADD_IMAGE_PATH)->GetWindowText(buf, MAX_LEN);
		ip.fileName = buf;
	GetDlgItem(IDC_EDIT_ADD_IMAGES_X1)->GetWindowText(buf, MAX_LEN);
		pt.x = atoi(buf);
	GetDlgItem(IDC_EDIT_ADD_IMAGES_Y1)->GetWindowText(buf, MAX_LEN);
		pt.y = atoi(buf);

	ip.upperLeft = pt;

	/*if(!_doDisplay2)
		_display.images1.push_back( ip);
	else 
		_display.images2.push_back(ip);*/

	if(_whichDisplay == 1)
		_display.images1.push_back(ip);
	else if(_whichDisplay ==2 )
		_display.images2.push_back(ip);
	else if(_whichDisplay == 3)
		_display.images3.push_back(ip);
	std::ostringstream os;
	os << '(' <<pt.x << ' ' << pt.y << ") "<< ip.fileName;
		
//	lb.DeleteString(idx);
	lb.AddString( os.str().c_str());
	lb.SetSel(-1);	
}

void CEditTrialImagesDialog::OnBnClickedButtonUpdateImage()
{
	const int MAX_LEN = 200;
	CListBox &lb = *((CListBox*)GetDlgItem(IDC_LIST_IMAGE_POSITIONS));
	int idx = lb.GetCurSel();
	char buf[MAX_LEN+1];

	if (idx == LB_ERR)
		return;

	IMAGEPOS ip;
	CPoint pt;

	GetDlgItem(IDC_EDIT_ADD_IMAGE_PATH)->GetWindowText(buf, MAX_LEN);
		ip.fileName = buf;
	GetDlgItem(IDC_EDIT_ADD_IMAGES_X1)->GetWindowText(buf, MAX_LEN);
		pt.x = atoi(buf);
	GetDlgItem(IDC_EDIT_ADD_IMAGES_Y1)->GetWindowText(buf, MAX_LEN);
		pt.y = atoi(buf);

	ip.upperLeft = pt;

/*	if(!_doDisplay2)
		_display.images1.at(idx) = ip;
	else 
		_display.images2.at(idx) = ip;*/

	if(_whichDisplay == 1)
		_display.images1.at(idx) = ip;
	else if(_whichDisplay == 2)
		_display.images2.at(idx) = ip;
	else if(_whichDisplay == 3)
		_display.images3.at(idx) = ip;
	std::ostringstream os;
	os << '(' <<pt.x << ' ' << pt.y << ") "<< ip.fileName;
		
	lb.DeleteString(idx);
	lb.InsertString(idx, os.str().c_str());
	lb.SetSel(-1);
}

void CEditTrialImagesDialog::OnBnClickedButtonDeleteImage()
{
//	const int MAX_LEN = 200;
	CListBox &lb = *((CListBox*)GetDlgItem(IDC_LIST_IMAGE_POSITIONS));
	int idx = lb.GetCurSel();
//	char buf[MAX_LEN+1];

	if (idx == LB_ERR)
		return;

	lb.DeleteString(idx);

	if(_whichDisplay == 1){
		std::vector<IMAGEPOS>::iterator iter = _display.images1.begin();
		for(int i=0; i<idx; i++, iter++);
		_display.images1.erase(iter);
	}
	else if(_whichDisplay == 2){
		std::vector<IMAGEPOS>::iterator iter = _display.images2.begin();
		for(int i=0; i<idx; i++, iter++);
		_display.images2.erase(iter);
	}
	else if(_whichDisplay == 3){
		std::vector<IMAGEPOS>::iterator iter = _display.images3.begin();
		for(int i=0; i<idx; i++, iter++);
		_display.images3.erase(iter);
	}

	lb.SetSel(-1);

	GetDlgItem(IDC_EDIT_ADD_IMAGE_PATH)->SetWindowText("");
	GetDlgItem(IDC_EDIT_ADD_IMAGES_X1)->SetWindowText("");
	GetDlgItem(IDC_EDIT_ADD_IMAGES_Y1)->SetWindowText("");
}

void CEditTrialImagesDialog::OnBnClickedButtonBrowseImages()
{
	char filterExt[] = "Bitmap Files (*.bmp)|*.bmp|All Files (*.*)|*.*||";
	CFileDialog fileDlg(true, "bmp", NULL, OFN_FILEMUSTEXIST, filterExt, this);

	if(fileDlg.DoModal() == IDOK) {
		GetDlgItem(IDC_EDIT_ADD_IMAGE_PATH)->SetWindowText(fileDlg.GetPathName());
	}
	// TODO: Add your control notification handler code here
}

void CEditTrialImagesDialog::OnEnChangeEditAddImagePath()
{
	// TODO:  If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO:  Add your control notification handler code here
}

DisplayData CEditTrialImagesDialog::getDisplayData(){
	return _display;
}