/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include "afxwin.h"
#include "TrialId.h"
#include "trial-type.hpp"

class CEditTrialPropertiesDialog : public CDialog
{
	DECLARE_DYNAMIC(CEditTrialPropertiesDialog)

public:
	CEditTrialPropertiesDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~CEditTrialPropertiesDialog();

	enum { IDD = IDD_EDIT_TRIAL_PROPERTIES_DIALOG };

	TrialId &trialId();

	std::string &typeName();

	Tokenizer::ButtonType &questionAnswer();

	Tokenizer::ControlType &controlType();

	int &maxDisplayTime();

	virtual BOOL OnInitDialog();

	afx_msg void OnBnClickedDependent();
	afx_msg void OnBnClickedQuestion();
	afx_msg void OnCbnSelchangeAnswer();
	afx_msg void OnCbnSelchangeConditionType();
	afx_msg void OnChangeTrialType();
	afx_msg void OnEnKillfocusEditCondition();
	afx_msg void OnEnKillfocusEditIndex();
	afx_msg void OnEnKillfocusEditItem();
	afx_msg void OnEnKillfocusEditTime();

	void SetTrialTypeNames(const StringList &list);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();

	DECLARE_MESSAGE_MAP()

private:
	CComboBox m_comboAnswer;
	CComboBox m_comboTypeNames;
	CComboBox m_comboAnswer2;

	StringList			  _typeNameList;
	Tokenizer::ButtonType _answer;
	TrialId				  _identifier;
	std::string			  _typeName;
	int					  _maxTime;
	bool				  _isQuestion;
	Tokenizer::ControlType _controlType;

public:
	afx_msg void OnCbnSelchangeComboTrialPropertyAnswer2();
};
