/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once
#include "afxwin.h"
#include "resource.h"
#include "experiment.hpp"

// CEditTrialTypeDlg dialog

class CEditTrialTypeDlg : public CDialog
{
	DECLARE_DYNAMIC(CEditTrialTypeDlg)

public:
	CEditTrialTypeDlg(CWnd* pParent);            // standard constructor
	virtual ~CEditTrialTypeDlg();

// Dialog Data
	enum { IDD = IDD_EDITTRIALTYPEDLG };

	TrialType GetTrialType();

	virtual BOOL OnInitDialog();

	afx_msg void OnBnClickedChangeAudio();
	afx_msg void OnBnClickedChangeText();
	afx_msg void OnBnClickedEnableAudio();
	afx_msg void OnBnClickedEnableText();
	afx_msg void OnBnClickedOutputStream();
	afx_msg void OnBnClickedOutputNostream();
	afx_msg void OnBnClickedRevertDisplayChange();
	afx_msg void OnBnClickedTriggerDriftandgaze();
	afx_msg void OnBnClickedTriggerDriftcorrect();
	afx_msg void OnBnClickedTriggerGaze();
	afx_msg void OnBnClickedTriggerNogaze();

	void SetTrialType(TrialType *t);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();
	void SetCheckBoxes(Tokenizer::OutputType output, 
					   Tokenizer::TriggerType trigger, 
					   bool revertDisplay,
					   Tokenizer::ControlType control);
	void updateButtonList();

	DECLARE_MESSAGE_MAP()

private:
	CListBox    mListButtons;                    //list box for button types

	std::string            _identifier;
	AudioCaptureData       _audioFmt;
	TextFormat             _textFmt;
	TextFormat				_textFmt2;
	Tokenizer::ButtonType  _button[10];
	Tokenizer::OutputType  _output;
	Tokenizer::ControlType _controlType;
	Tokenizer::TriggerType _trigger;
	int                    _cursor;
	int                    _dcDelay;
	int                    _stimDelay;
	int                    _nButtons;
	bool                   _enableAudioCapture;
	bool                   _enableText;
	bool                   _revertDisplay;

	CToolTipCtrl *m_ToolTip;
public:
	afx_msg void OnBnClickedOk();
	afx_msg void OnEnChangeEditTrialtypeId();
	afx_msg void OnLbnSelchangeListTrialtypeButtons();
	afx_msg void OnBnClickedRadio5ButtonControl();
	afx_msg void OnBnClickedRadio7ButtonControl();
	afx_msg void OnEnChangeEditTrialtypeDcDelay();
	BOOL PreTranslateMessage(MSG* pMsg);
};
