/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include "ChildView.h"
#include "experiment.hpp"

class CMainFrame : public CFrameWnd
{
public:
	CMainFrame();
	virtual ~CMainFrame();

	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

	afx_msg void OnClose();
	afx_msg void OnMenuAddSequence();
	afx_msg void OnMenuAddTrial();
	afx_msg void OnMenuAddTrialType();
	afx_msg void OnMenuClose();
	afx_msg void OnMenuEditExperiment();
	afx_msg void OnMenuNew();
	afx_msg void OnMenuOpen();
	afx_msg void OnMenuRunExpt();
	afx_msg void OnMenuSave();
	afx_msg void OnMenuSaveAs();
	afx_msg void OnMenuTestExpt();
	afx_msg void OnMenuValidateExpt();
	afx_msg void OnSize(UINT nType, int cx, int cy);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CSplitterWnd m_wndSplt;
	//CStatusBar   m_wndStatusBar;

	DECLARE_DYNAMIC(CMainFrame)

	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

	bool InitializeExperiment(IdentifierList &trials, bool isExp = false);

	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);

	afx_msg void OnSetFocus(CWnd *pOldWnd);

	void EditSequence(CTreeCtrl &ctrl, HTREEITEM item);
	void EditTrial(CTreeCtrl &ctrl, HTREEITEM item);
	void EditTrialType(CTreeCtrl &ctrl, HTREEITEM item);
	void UpdateView();

	DECLARE_MESSAGE_MAP()

private:
	void statusReady();
	HTREEITEM   _sequenceTreeRoot;
	HTREEITEM   _trialTreeRoot;
	HTREEITEM   _typeTreeRoot;
	HTREEITEM	_dudRoot;
	Experiment *_experiment;                //the single experiment
	std::string _expFileName;               //name of experiment file
	std::string _expFileTitle;

};
