#pragma once

#include "Tokenizer.h"
#include "TrialId.h"

class Sequence {
public:
	Sequence(const IdentifierList &seq,const IdentifierList &altseq, const std::string &indepTrialId, Tokenizer::ButtonType b);
	Sequence(const IdentifierList &seq,const IdentifierList &altseq, const std::string &indepTrialId);
	Sequence(const IdentifierList &seq, const std::string &indepTrialId);
	Sequence(Tokenizer &tok);
	Sequence(const Sequence &seq);
	~Sequence();

	const Sequence &operator=(const Sequence &rhs);

	const TrialId &identifier() const;
	const TrialId &nextTrialId();
	const TrialId &nextAltId();

	int length() const;
	int altLength() const;
	int altSelectButton() const;

	bool atEnd() const;
	bool atAltEnd() const;

	void appendToList(IdentifierList &list) const;
	void resetTrialPtr();
	void save(std::ostream &os) const;

protected:
	IdentifierList _sequence;
	IdentifierList _altSequence;
	IdentifierIter _sPtr;
	IdentifierIter _altPtr;
	TrialId        _identifier;
	int				_altSelectButton;
};

typedef std::list<Sequence*>                 SequenceList;
typedef std::list<Sequence*>::iterator       SequenceIter;
typedef std::list<Sequence*>::const_iterator constSequenceIter;