/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include "trial-type.hpp"

class CTextDlg : public CFontDialog
{
	DECLARE_DYNAMIC(CTextDlg)

public:
	CTextDlg(LPLOGFONT lplfInitial = NULL, DWORD dwFlags = CF_EFFECTS | CF_SCREENFONTS,
			CDC* pdcPrinter = NULL,	CWnd* pParentWnd = NULL);
	TextFormat _format;

#ifndef _AFX_NO_RICHEDIT_SUPPORT
	CTextDlg(const CHARFORMAT& charformat, DWORD dwFlags = CF_SCREENFONTS,
			CDC* pdcPrinter = NULL,	CWnd* pParentWnd = NULL);
#endif

	virtual ~CTextDlg();

	const TextFormat &GetTextFormat();

	virtual BOOL OnInitDialog();

	void SetTextFormat(const TextFormat &format);

protected:
	DECLARE_MESSAGE_MAP()

	virtual void OnOK();

public:
	afx_msg void OnEnChangeEditOffsetXPt();
	afx_msg void OnEnChangeEditOffsetYPt();
	afx_msg void OnEnChangeEditOffsetYPix();
	afx_msg void OnEnChangeEditOffsetXPix();
	afx_msg void OnEnChangePts();
	afx_msg void OnEnChangePix();

private:
	bool points;
	bool loaded;


//private:
//	TextFormat _format;
};


