/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include "bitmapFile.h"
#include "Experiment.hpp"
#include "EditTrialDisplayDialog.h"

class CTrialWnd : public CWnd
{
	DECLARE_DYNAMIC(CTrialWnd)

public:
	CTrialWnd();
	virtual ~CTrialWnd();

	void DrawBackground(const std::string &image);
	void DrawDCRect(const CRect &r, bool isSelected);
	void DrawGCRect(const CRect &r);
	void DrawText(const std::string &text, const TextFormat &fmt, DisplayData dd, int doDisplay, int spacingDiff);
	void SetWindowColors(COLORREF backColor, COLORREF foreColor = 0x0);
	void setEditDisplayCwnd(CEditTrialDisplayDialog edit);

	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);

	CPoint getUpperLeft();
	CPoint getLowerRight();

protected:
	DECLARE_MESSAGE_MAP()

	virtual void PostNcDestroy();

private:
	CBitmapFile _bitmap;                         //bitmap for trial text
	CPoint      _mousePt;
	CPoint		_upperLeft;
	CPoint		_lowerRight;
	bool		_rButtonDown;
	CRect       _wndSz;                          //dimensions of the window
	COLORREF    _backColor;                      //window background color
	COLORREF    _foreColor;                      //window foreground color
	CEditTrialDisplayDialog*		_editWnd;

};
