/*  Eyetracking software creates and executes experiments using 
    Eyelink II hardware and libraries by SR Research

    Copyright (C) 2004  David J. Stracuzzi, University of Massachusetts

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once
#pragma warning( disable : 4290 )

#include "stdafx.h"
#include "Mmreg.h"
#include "dsound.h"
#include "waveException.h"
#include <fstream>
#include <string>

class CWaveFile {
public:
	CWaveFile(const std::string &fileName, bool openForRead) throw(CWaveException);
	~CWaveFile();

	DWORD nSamples() const;

	void close();
	void readHeader(WAVEFORMATEX *format) throw(CWaveException);
	void readWaveData(void *buf, int nBytes) throw(CWaveException);
	void reset();
	void writeHeader(const WAVEFORMATEX *format);
	void writeWaveData(const void *buf, int nBytes);

protected:
	union ByteMap {
		DWORD dword;
		WORD  word;
		BYTE  bytes[4];
	};

private:
	std::fstream _waveFile;
	DWORD        _nSamples;
	DWORD        _sampleSize;
	bool         _isReading;
};
